<?php
/*
 Plugin Name: WordPress Related Posts with Thumb Revised
 Version: 0.1
 Plugin URI: http://fabrizio.zellini.org/wordpress-related-posts-with-thumbs-revised
 Description: Generate a related posts list via tags of WorPdress with Thumbnail
 Author: Fabrizio Zellini
 Author URI: http://fabrizio.zellini.org

 Copyright (c) 2008
 Released under the GPL license
 http://www.gnu.org/licenses/gpl.txt

 This file is part of WordPress.
 WordPress is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	INSTALL:
	Just install the plugin in your blog and activate
	be sure that directory "picscache" is writable by all (chmod 777)  
	*/

require_once 'std.encryption.class.inc';

load_plugin_textdomain('wp_related_posts',PLUGINDIR . '/' . dirname(plugin_basename (__FILE__)) . '/lang');

function wp_get_related_posts() {
  global $wpdb, $post,$table_prefix;
  $wp_rp = get_option("wp_rp");

  $exclude = explode(",",$wp_rp["wp_rp_exclude"]);
  $limit = $wp_rp["wp_rp_limit"];
  $wp_rp_thumb_size = $wp_rp["wp_rp_thumb_size"];
  $wp_rp_title = $wp_rp["wp_rp_title"];
  $wp_no_rp = $wp_rp["wp_no_rp"];
  $wp_no_rp_text = $wp_rp["wp_no_rp_text"];
  $show_date = $wp_rp["wp_rp_date"];
  $show_comments_count = $wp_rp["wp_rp_comments"];
  $wp_rp_randomize = $wp_rp["wp_rp_randomize"];
  
  if (!$wp_rp_thumb_size) $wp_rp_thumb_size="46x60c";

  if ( $exclude != '' ) {
    $q = "SELECT tt.term_id FROM ". $table_prefix ."term_taxonomy tt, " . $table_prefix . "term_relationships tr WHERE tt.taxonomy = 'category' AND tt.term_taxonomy_id = tr.term_taxonomy_id AND tr.object_id = $post->ID";

    $cats = $wpdb->get_results($q);

    foreach(($cats) as $cat) {
      if (in_array($cat->term_id, $exclude) != false){
        return;
      }
    }
  }

  if(!$post->ID){return;}
  $now = current_time('mysql', 1);
  $tags = wp_get_post_tags($post->ID);
  
  $taglist = "'" . $tags[0]->term_id. "'";

  $tagcount = count($tags);
  if ($tagcount > 1) {
    for ($i = 1; $i <= $tagcount; $i++) {
      $taglist = $taglist . ", '" . $tags[$i]->term_id . "'";
    }
  }

  if ($limit) {
    if ($wp_rp_randomize){
      $limitclause = "LIMIT ".$limit*2;
    } else {
      $limitclause = "LIMIT ".$limit;
    }
    $quante=$limit;
  } else {
    if ($wp_rp_randomize){
      $limitclause = "LIMIT 20";
    } else {
      $limitclause = "LIMIT 10";
    }
    $quante=10;
  }
  $q = "SELECT DISTINCT p.ID, p.post_title, p.post_content, p.post_date, p.comment_count, count(t_r.object_id) as cnt FROM $wpdb->term_taxonomy t_t, $wpdb->term_relationships t_r, $wpdb->posts p WHERE t_t.taxonomy ='post_tag' AND t_t.term_taxonomy_id = t_r.term_taxonomy_id AND t_r.object_id  = p.ID AND (t_t.term_id IN ($taglist)) AND p.ID != $post->ID AND p.post_status = 'publish' AND p.post_date_gmt < '$now' GROUP BY t_r.object_id ORDER BY cnt DESC, p.post_date_gmt DESC $limitclause;";

  $related_posts = $wpdb->get_results($q);
  if ($wp_rp_randomize) shuffle ($related_posts);
  $output = "";

  if (!$related_posts){

    if(!$wp_no_rp || ($wp_no_rp == "popularity" && !function_exists('akpc_most_popular'))) $wp_no_rp = "text";

    if($wp_no_rp == "text"){
      if(!$wp_no_rp_text) $wp_no_rp_text= __("No Related Post",'wp_related_posts');
      $output  .= '<li>'.$wp_no_rp_text .'</li>';
    }	else{
      if($wp_no_rp == "random"){
        if(!$wp_no_rp_text) $wp_no_rp_text= __("Random Posts",'wp_related_posts');
        $related_posts = wp_get_random_posts($limitclause);
      }	elseif($wp_no_rp == "commented"){
        if(!$wp_no_rp_text) $wp_no_rp_text= __("Most Commented Posts",'wp_related_posts');
        $related_posts = wp_get_most_commented_posts($limitclause);
        if ($wp_rp_randomize) shuffle ($related_posts);
      }	elseif($wp_no_rp == "popularity"){
        if(!$wp_no_rp_text) $wp_no_rp_text= __("Most Popular Posts",'wp_related_posts');
        $related_posts = wp_get_most_popular_posts($limitclause);
        if ($wp_rp_randomize) shuffle ($related_posts);
      }else{
        return __("Something wrong",'wp_related_posts');;
      }
      $wp_rp_title = $wp_no_rp_text;
    }
  }

  $resizepath= realpath(dirname(__FILE__).'/resize.php');
  $zkey="UNIQUE-".filemtime($resizepath);
  $blogurl = get_bloginfo('home');

  foreach ($related_posts as $related_post ){
    if ($quante--==0) break;
    //inizio formattazione output
    $all_post_text = $related_post->post_content;
    // estrazione della prima immagine
    $first_img=false;
    $resized_url=false;
    if ( preg_match  ( '/<img.*?src=["\'](.*?)["\'].*?>/i',$all_post_text,  $matches)){
		    $first_img = $matches[1];
		    $crypt = new encryption_class;
		    $dimension_encoded = urlencode ($crypt->encrypt($zkey,$wp_rp_thumb_size));
		    $imgurl_encoded = urlencode ($crypt->encrypt($zkey,$first_img));
		    $resized_url = $blogurl."/wp-content/plugins/WPRPT/resize.php?size=".$dimension_encoded."&url=".$imgurl_encoded;
    }
    $text_content = strip_tags($related_post->post_content); // toglie i tag html dal testo
    $text_content = truncateText($text_content,150,'...',false,true); //numero di caratteri da mostrare del testo
    $attachment_id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_parent = '$related_post->ID' AND post_status = 'inherit' AND post_type='attachment' ORDER BY post_date DESC LIMIT 1");
    $output .= "<li>\n";
    if ($resized_url) {
      $output .= '  <div class="img_related_post"><img src="'.$resized_url.'"/></div>'."\n";
    } else {
      $output .= '  <div class="img_related_post">'.get_attachment_icon($attachment_id).'</div>'."\n";
    }
    $output .=  '  <div class="text_related_post">'."\n".'    <a href="'.get_permalink($related_post->ID).'" title="'.wptexturize($related_post->post_title).'">'.wptexturize($related_post->post_title)."</a>\n    <p>".$text_content.'</p>'."\n";
    if ($show_date){
      $dateformat = get_option('date_format');
      $output .=   "    <span class='publi_related_post'>Pubblicato il:</span> <span class='publi_related_post_date'>".mysql2date($dateformat, $related_post->post_date) . "</span>\n";
    }
    if ($show_comments_count){
      $output .=  "    <span class='comments_related_post'>Commenti: " . $related_post->comment_count . "</span>\n";
    }
    $output .=  "  </div>\n";
    $output .= "</li>\n";
  }
  $output = '<ul class="related_post">' . "\n". $output . "\n".'</ul>';
  //fine formattazione
  if($wp_rp_title != '') $output =  '<h3>'.$wp_rp_title .'</h3>'. $output;
  return $output;
}
function truncateText ($text, $length = 100, $ending = '...', $exact = true, $considerHtml = false) {
  if ($considerHtml) {
    // if the plain text is shorter than the maximum length, return the whole text
    if (strlen(preg_replace('/<.*?>/', '', $text)) <= $length) {
      return $text;
    }

    // splits all html-tags to scanable lines
    preg_match_all('/(<.+?>)?([^<>]*)/s', $text, $lines, PREG_SET_ORDER);

    $total_length = strlen($ending);
    $open_tags = array();
    $truncate = '';

    foreach ($lines as $line_matchings) {
      // if there is any html-tag in this line, handle it and add it (uncounted) to the output
      if (!empty($line_matchings[1])) {
        // if it's an "empty element" with or without xhtml-conform closing slash (f.e. <br/>)
        if (preg_match('/^<(\s*.+?\/\s*|\s*(img|br|input|hr|area|base|basefont|col|frame|isindex|link|meta|param)(\s.+?)?)>$/is', $line_matchings[1])) {
          // do nothing
          // if tag is a closing tag (f.e. </b>)
        } else if (preg_match('/^<\s*\/([^\s]+?)\s*>$/s', $line_matchings[1], $tag_matchings)) {
          // delete tag from $open_tags list
          $pos = array_search($tag_matchings[1], $open_tags);
          if ($pos !== false) {
            unset($open_tags[$pos]);
          }
          // if tag is an opening tag (f.e. <b>)
        } else if (preg_match('/^<\s*([^\s>!]+).*?>$/s', $line_matchings[1], $tag_matchings)) {
          // add tag to the beginning of $open_tags list
          array_unshift($open_tags, strtolower($tag_matchings[1]));
        }
        // add html-tag to $truncate'd text
        $truncate .= $line_matchings[1];
      }

      // calculate the length of the plain text part of the line; handle entities as one character
      $content_length = strlen(preg_replace('/&[0-9a-z]{2,8};|&#[0-9]{1,7};|&#x[0-9a-f]{1,6};/i', ' ', $line_matchings[2]));
      if ($total_length+$content_length > $length) {
        // the number of characters which are left
        $left = $length - $total_length;
        $entities_length = 0;
        // search for html entities
        if (preg_match_all('/&[0-9a-z]{2,8};|&#[0-9]{1,7};|&#x[0-9a-f]{1,6};/i', $line_matchings[2], $entities, PREG_OFFSET_CAPTURE)) {
          // calculate the real length of all entities in the legal range
          foreach ($entities[0] as $entity) {
            if ($entity[1]+1-$entities_length <= $left) {
              $left--;
              $entities_length += strlen($entity[0]);
            } else {
              // no more characters left
              break;
            }
          }
        }
        $truncate .= substr($line_matchings[2], 0, $left+$entities_length);
        // maximum lenght is reached, so get off the loop
        break;
      } else {
        $truncate .= $line_matchings[2];
        $total_length += $content_length;
      }

      // if the maximum length is reached, get off the loop
      if($total_length >= $length) {
        break;
      }
    }
  } else {
    if (strlen($text) <= $length) {
      return $text;
    } else {
      $truncate = substr($text, 0, $length - strlen($ending));
    }
  }

  // if the words shouldn't be cut in the middle...
  if (!$exact) {
    // ...search the last occurance of a space...
    $spacepos = strrpos($truncate, ' ');
    if (isset($spacepos)) {
      // ...and cut the text in this position
      $truncate = substr($truncate, 0, $spacepos);
    }
  }

  // add the defined ending to the text
  $truncate .= $ending;

  if($considerHtml) {
    // close all unclosed html-tags
    foreach ($open_tags as $tag) {
      $truncate .= '</' . $tag . '>';
    }
  }

  return $truncate;

}
//funzione da richiamare nel template
function wp_related_posts(){

  $output = wp_get_related_posts() ;
  echo $output;
}

function wp23_related_posts() {
  wp_related_posts();
}

function wp_related_posts_for_feed($content=""){
  $wp_rp = get_option("wp_rp");
  $wp_rp_rss = ($wp_rp["wp_rp_rss"] == 'yes') ? 1 : 0;
  if ( (! is_feed()) || (! $wp_rp_rss)) return $content;

  $output = wp_get_related_posts() ;
  $content = $content . $output;

  return $content;
}

add_filter('the_content', 'wp_related_posts_for_feed',1);

function wp_related_posts_auto($content=""){
  $wp_rp = get_option("wp_rp");
  $wp_rp_auto = ($wp_rp["wp_rp_auto"] == 'yes') ? 1 : 0;
  if ( (! is_single()) || (! $wp_rp_auto)) return $content;

  $output = wp_get_related_posts() ;
  $content = $content . $output;

  return $content;
}

add_filter('the_content', 'wp_related_posts_auto',99);

function wp_get_random_posts ($limitclause="") {
  global $wpdb, $tableposts, $post;

  $q = "SELECT ID, post_title, post_content,post_date, comment_count FROM $tableposts WHERE post_status = 'publish' AND post_type = 'post' AND ID != $post->ID ORDER BY RAND() $limitclause";
  return $wpdb->get_results($q);
}


function wp_get_most_commented_posts($limitclause="") {
  global $wpdb;
  $q = "SELECT ID, post_title,post_content, post_date, COUNT($wpdb->comments.comment_post_ID) AS 'comment_count' FROM $wpdb->posts, $wpdb->comments WHERE comment_approved = '1' AND $wpdb->posts.ID=$wpdb->comments.comment_post_ID AND post_status = 'publish' GROUP BY $wpdb->comments.comment_post_ID ORDER BY comment_count DESC $limitclause";
  return $wpdb->get_results($q);
}

function wp_get_most_popular_posts ($limitclause="") {
  global $wpdb, $table_prefix;

  $q = $sql = "SELECT p.ID, p.post_title, p.post_date, p.comment_count FROM ". $table_prefix ."ak_popularity as akpc,".$table_prefix ."posts as p WHERE p.ID = akpc.post_id ORDER BY akpc.total DESC $limitclause";;
  return $wpdb->get_results($q);
}

add_action('admin_menu', 'wp_add_related_posts_options_page');

function wp_add_related_posts_options_page() {
  if (function_exists('add_options_page')) {
    add_options_page( __('WordPress Related Posts','wp_related_posts'), __('WordPress Related Posts','wp_related_posts'), 8, basename(__FILE__), 'wp_related_posts_options_subpanel');
  }
}

function wp_related_posts_options_subpanel() {
  if($_POST["wp_rp_Submit"]){
    $message = "WordPress Related Posts Setting Updated";

    $wp_rp_saved = get_option("wp_rp");

    $wp_rp = array (
    "wp_rp_title" 	=> $_POST['wp_rp_title_option'],
    "wp_no_rp"		=> $_POST['wp_no_rp_option'],
    "wp_no_rp_text"	=> $_POST['wp_no_rp_text_option'],
    "wp_rp_limit"	=> $_POST['wp_rp_limit_option'],
    "wp_rp_thumb_size"	=> $_POST['wp_rp_thumb_size_option'],
    'wp_rp_exclude'	=> $_POST['wp_rp_exclude_option'],
    'wp_rp_auto'	=> $_POST['wp_rp_auto_option'],
    'wp_rp_rss'		=> $_POST['wp_rp_rss_option'],
    'wp_rp_comments'=> $_POST['wp_rp_comments_option'],
    'wp_rp_date'	=> $_POST['wp_rp_date_option'],
    'wp_rp_randomize'   => $_POST['wp_rp_randomize_option']
    );

    if ($wp_rp_saved != $wp_rp)
    if(!update_option("wp_rp",$wp_rp))
				$message = "Update Failed";

				echo '<div id="message" class="updated fade"><p>'.$message.'.</p></div>';
  }

  $wp_rp = get_option("wp_rp");
  ?>
<div class="wrap">
<h2 id="write-post"><?php _e("Related Posts Options&hellip;",'wp_related_posts');?></h2>
<p><?php _e("WordPress Related Posts Plugin will generate a related posts via WordPress tags, and add the related posts to feed.",'wp_related_posts');?></p>
<form method="post"
	action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo basename(__FILE__); ?>">
<h3><?php _e("Related Posts Preference",'wp_related_posts');?></h3>
<table class="form-table">
	<tr>
		<th><?php _e("Related Posts Title:",'wp_related_posts'); ?></th>
		<td><input type="text" name="wp_rp_title_option"
			value="<?php echo $wp_rp["wp_rp_title"]; ?>" /></td>
	</tr>
	<tr>
		<th><?php _e("When No Related Posts, Dispaly:",'wp_related_posts'); ?></th>
		<td><?php $wp_no_rp = $wp_rp["wp_no_rp"]; ?> <select
			name="wp_no_rp_option">
			<option value="text" <?php if($wp_no_rp == 'text') echo 'selected' ?>><?php _e("Text: 'No Related Posts'",'wp_related_posts'); ?></option>
			<option value="random"
			<?php if($wp_no_rp == 'random') echo 'selected' ?>><?php _e("Random Posts",'wp_related_posts'); ?></option>
			<option value="commented"
			<?php if($wp_no_rp == 'commented') echo 'selected' ?>><?php _e("Most Commented Posts",'wp_related_posts'); ?></option>
			<?php if (function_exists('akpc_most_popular')){ ?>
			<option value="popularity"
			<?php if($wp_no_rp == 'popularity') echo 'selected' ?>><?php _e("Most Popular Posts",'wp_related_posts'); ?></option>
			<?php } ?>
		</select></td>
	</tr>
	<tr>
		<th><?php _e("No Related Post's Title or Text:",'wp_related_posts'); ?></th>
		<td><input type="text" name="wp_no_rp_text_option"
			value="<?php echo $wp_rp["wp_no_rp_text"]; ?>" /></td>
	</tr>
	<tr>
		<th><?php _e("Limit:",'wp_related_posts');?></th>
		<td><input type="text" name="wp_rp_limit_option"
			value="<?php echo $wp_rp["wp_rp_limit"]; ?>" /></td>
	</tr>
	<tr>
		<th><?php _e("Thumbnail size:",'wp_related_posts');?></th>
		<td><input type="text" name="wp_rp_thumb_size_option"
			value="<?php echo $wp_rp["wp_rp_thumb_size"]; ?>" /></td>
	</tr>
	
	<tr>
		<th><?php _e("Exclude(category IDs):",'wp_related_posts');?></th>
		<td><input type="text" name="wp_rp_exclude_option"
			value="<?php echo $wp_rp["wp_rp_exclude"]; ?>" /></td>
	</tr>
	<tr>
		<th><?php _e("Other Setting:",'wp_related_posts');?></th>
		<td><label> <?php
		if ( $wp_rp["wp_rp_auto"] == 'yes' ) {
		  echo '<input name="wp_rp_auto_option" type="checkbox" value="yes" checked>';
		} else {
		  echo '<input name="wp_rp_auto_option" type="checkbox" value="yes">';
		}
		?> <?php _e("Auto Insert Related Posts",'wp_related_posts');?> </label>
		<br />
		<label> <?php
		if ( $wp_rp["wp_rp_rss"] == 'yes' ) {
		  echo '<input name="wp_rp_rss_option" type="checkbox" value="yes" checked>';
		} else {
		  echo '<input name="wp_rp_rss_option" type="checkbox" value="yes">';
		}
		?> <?php _e("Related Posts for RSS",'wp_related_posts');?> </label> <br />
		<label> <?php
		if ( $wp_rp["wp_rp_comments"] == 'yes' ) {
		  echo '<input name="wp_rp_comments_option" type="checkbox" value="yes" checked>';
		} else {
		  echo '<input name="wp_rp_comments_option" type="checkbox" value="yes">';
		}
		?> <?php _e("Display Comments Count",'wp_related_posts');?> </label> <br />
		<label> <?php
		if ( $wp_rp["wp_rp_date"] == 'yes' ) {
		  echo '<input name="wp_rp_date_option" type="checkbox" value="yes" checked>';
		} else {
		  echo '<input name="wp_rp_date_option" type="checkbox" value="yes">';
		}
		?> <?php _e("Display Post Date",'wp_related_posts');?> </label> <br />
                <label><?php
		if ( $wp_rp["wp_rp_randomize"] == 'yes' ) {
		  echo '<input name="wp_rp_randomize_option" type="checkbox" value="yes" checked>';
		} else {
		  echo '<input name="wp_rp_randomize_option" type="checkbox" value="yes">';
		}
		?> <?php _e("Randomize related post",'wp_related_posts');?> </label> <br />		
		</td>
	</tr>
</table>

<p class="submit"><input type="submit"
	value="<?php _e("Update Preferences &raquo;",'wp_related_posts');?>"
	name="wp_rp_Submit" /></p>
</form>
</div>
		<?php }?>